#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_ShopCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_ShopCFG> Fish_ShopCFG::msSingleton(nullptr);

int Fish_ShopCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ShopCFGData* Fish_ShopCFG::GetData(int ShopID)
{
	auto it = mMapData.find(ShopID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_ShopCFGData>& Fish_ShopCFG::GetMapData()
{
	return mMapData;
}

void Fish_ShopCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_ShopCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ShopCFGData data;
		data.mShopID = element->IntAttribute("ShopID");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mConsumeType = element->IntAttribute("ConsumeType");
		data.mKnapsackType = element->IntAttribute("KnapsackType");
		data.mConsumeCount = element->IntAttribute("ConsumeCount");
		{
			const char* ShowType = element->Attribute("ShowType");
			std::vector<std::string> vecShowType;
			boost::split(vecShowType, ShowType, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowType.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowType[i].c_str(), &temp))
				{
					data.mShowType.push_back(temp);
				}
			}
		}
		data.mSynthesisId = element->IntAttribute("SynthesisId");
		data.mNeedVIP = element->IntAttribute("NeedVIP");
		data.mShopTab = element->IntAttribute("ShopTab");
		data.mRelease = element->IntAttribute("Release");
		data.mReleaseVIP = element->IntAttribute("ReleaseVIP");
		data.mTurrestId = element->IntAttribute("TurrestId");
		if (mMapData.find(data.mShopID) != mMapData.end())std::cout <<"data refind:" << data.mShopID << std::endl;
		assert(mMapData.find(data.mShopID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mShopID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_ShopCFG::Load()
{
	Load("../Config/Fish_ShopCFG.xml");
}

Fish_ShopCFG* Fish_ShopCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ShopCFG());
	}
	return msSingleton.get();
}
